%define major         6
%define utf8libname   %mklibname %{name}w %{major}
%define libname       %mklibname %{name} %{major}
%define utf8lib5name  %mklibname %{name}w 5
%define lib5name      %mklibname %{name} 5
%define develname     %mklibname -d %{name}
%define utf8develname %mklibname -d %{name}w
%define revision      20161105

Summary:	A CRT screen handling and optimization package
Name:		ncurses
Version:	6.0
Release:	%mkrel 2
License:	MIT
Group:		System/Libraries
Url:		http://www.gnu.org/software/ncurses/ncurses.html
Source0:	ftp://invisible-island.net/ncurses/current/%{name}-%{version}-%{revision}.tar.xz
Source4:	ncurses-resetall.sh
Source5:    ncurses-usefull-terms
Patch0:		ncurses-5.6-xterm-debian.patch
Patch7:		ncurses-compheader.patch
Patch11:	ncurses-urxvt.patch
BuildRequires:	gpm-devel
BuildRequires:	sharutils
Conflicts:	%{name}-extraterms < 6.0-1
Obsoletes:	termcap
Provides:	termcap = %{version}-%{release}

%description
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n	%{libname}
Summary:	The development files for applications which use ncurses
Group:		System/Libraries

%description -n	%{libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n	%{utf8libname}
Summary:	Ncurses libraries which support UTF8
Group:		System/Libraries

%description -n	%{utf8libname}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

This package contains ncurses libraries which support wide char (UTF8),
and is not compatible with those without.

%package -n	%{lib5name}
Summary:	The development files for applications which use ncurses
Group:		System/Libraries

%description -n	%{lib5name}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

%package -n	%{utf8lib5name}
Summary:	Ncurses libraries which support UTF8
Group:		System/Libraries

%description -n	%{utf8lib5name}
The curses library routines are a terminal-independent method of updating
character screens with reasonalble optimization. The ncurses (new curses)
library is a freely distributable replacement for the discontinued 4.4BSD
classic curses library.

This package contains ncurses libraries which support wide char (UTF8),
and is not compatible with those without.

%package	extraterms
Summary:	Some exotic terminal descriptions
Group:		System/Libraries
Requires:	ncurses = %{version}-%{release}

%description	extraterms
Install the ncurses-extraterms package if you use some exotic terminals.

%package -n	%{develname}
Summary:	The development files for applications which use ncurses
Group:		Development/Libraries
Requires:	%{libname} = %{version}-%{release}
Provides:	lib%{name}-devel = %{version}-%{release}
Provides:	%{name}-devel = %{version}-%{release}
Obsoletes:	%{mklibname -d termcap} <= 2.0.8-53.mga3
Provides:	%{mklibname -d termcap} = %{version}-%{release}
Provides:	termcap-devel = %{version}-%{release}
Provides:	libtermcap-devel = %{version}-%{release}
Provides:	devel(libncurses(64bit))
Provides:	devel(libtermcap(64bit))

%description -n	%{develname}
The header files and libraries for developing applications that use
the ncurses CRT screen handling and optimization package.

Install the ncurses-devel package if you want to develop applications
which will use ncurses.

%package -n	%{utf8develname}
Summary:	The development files for applications which use ncurses
Group:		Development/Libraries
Requires:	%{develname} = %{version}-%{release}
Requires:	%{utf8libname} = %{version}-%{release}
Provides:	lib%{name}w-devel = %{version}-%{release}
Provides:	ncursesw-devel = %{version}-%{release}
Obsoletes:	%mklibname -d %{name}w 5
Conflicts:	%{_lib}ncurses-devel < 5.7
Provides:	devel(libncursesw(64bit))

%description -n	%{utf8develname}
The libraries for developing applications that use ncurses CRT screen
handling and optimization package. Install it if you want to develop
applications which will use ncurses.

Note that the libraries included here supports wide char (UTF-8),
and is not compatible with those without. When linking programs with
these libraries, you will have to append a "w" to the library names,
i.e. -lformw, -lmenuw, -lncursesw, -lpanelw.

%prep
%setup -q -n %{name}-%{version}-%{revision}

%patch7 -p1 -b .headercomp
%patch11 -p1 -b .urxvt

# regenerating configure needs patched autoconf, so modify configure
# directly
%patch0 -p1 -b .deb

find . -name "*.orig" | xargs rm -f
# fix some permissions
chmod 755 c++/edit_cfg.sh test/listused.sh test/configure test/tracemunch

%build
export PKG_CONFIG_LIBDIR=%{_libdir}/pkgconfig

ncurses_options="\
	--without-libtool \
	--with-shared \
	--with-cxx-shared \
	--with-normal \
	--without-debug \
	--enable-overwrite \
	--without-profile \
	--with-gpm \
	--enable-getcap \
	--enable-const \
	--enable-hard-tabs \
	--enable-hash-map \
	--enable-no-padding \
	--enable-sigwinch \
	--without-ada \
	--enable-xmc-glitch \
	--enable-colorfgbg \
	--enable-pc-files \
	--with-pkg-config-libdir=%{_libdir}/pkgconfig \
	--with-termlib=tinfo \
	--with-ospeed=unsigned \
	--with-xterm-kbs=DEL"

for abi in 5 6; do
  for width in normal utf8; do
    mkdir ncurses${abi}-${width}
    pushd ncurses${abi}-${width}
    CONFIGURE_TOP=..
    %configure2_5x \
    	$( echo $ncurses_options --with-abi-version=$abi
	[ $abi = 5 ] && echo --with-chtype=long
	[ $width = normal ] && echo --with-ticlib
	[ $width = utf8 ] && echo --enable-widec
	[ $abi = 6 -a $width = utf8 ] || echo --without-progs
	)

    %make libs
    if [ $abi -eq 6 -a $width = "utf8" ]; then
       %make -C progs
    fi
    popd
    done
done

%install
make -C ncurses5-normal DESTDIR=%{buildroot} install.libs
make -C ncurses5-utf8 DESTDIR=%{buildroot} install.libs

make -C ncurses6-normal DESTDIR=%{buildroot} install.libs
make -C ncurses6-utf8 DESTDIR=%{buildroot} install.{libs,progs,data,includes,man}

chmod 755 %{buildroot}%{_libdir}/lib*.so.*.*
chmod 644 %{buildroot}%{_libdir}/lib*.a

ln -sf ../l/linux %{buildroot}%{_datadir}/terminfo/c/console

# the resetall script
install -m 755 %{SOURCE4} %{buildroot}%{_bindir}/resetall
# we don't want this in doc
rm -f c++/demo

#
# FIXME
# OK do not time to debbug it now
#
cp %{buildroot}%{_datadir}/terminfo/x/xterm %{buildroot}%{_datadir}/terminfo/x/xterm2
cp %{buildroot}%{_datadir}/terminfo/x/xterm-new %{buildroot}%{_datadir}/terminfo/x/xterm


# We used to ship header files in ncurses subfolders, so replicate that structure
# Can't replace directory with symlink (rpm bug), so symlink all headers instead
mkdir -p %{buildroot}%{_includedir}/ncurses{,w}
for l in %{buildroot}%{_includedir}/*.h; do
    ln -s ../$(basename $l) %{buildroot}%{_includedir}/ncurses
    ln -s ../$(basename $l) %{buildroot}%{_includedir}/ncursesw
done


mkdir -p %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses.so.5 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses.so.5.9 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses.so.5.9 %{buildroot}%{_libdir}/libncurses.so.5.9
ln -s /%{_lib}/libncurses.so.5 %{buildroot}%{_libdir}/libncurses.so.5

mv %{buildroot}%{_libdir}/libncursesw.so.5 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncursesw.so.5.9 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncursesw.so.5.9 %{buildroot}%{_libdir}/libncursesw.so.5.9
ln -s /%{_lib}/libncursesw.so.5 %{buildroot}%{_libdir}/libncursesw.so.5

mv %{buildroot}%{_libdir}/libncurses++.so.5 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses++.so.5.9 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses++.so.5.9 %{buildroot}%{_libdir}/libncurses++.so.5.9
ln -s /%{_lib}/libncurses++.so.5 %{buildroot}%{_libdir}/libncurses++.so.5

mv %{buildroot}%{_libdir}/libtinfo.so.5 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libtinfo.so.5.9 %{buildroot}/%{_lib}
ln -s /%{_lib}/libtinfo.so.5.9 %{buildroot}%{_libdir}/libtinfo.so.5.9
ln -s /%{_lib}/libtinfo.so.5 %{buildroot}%{_libdir}/libtinfo.so.5


mv %{buildroot}%{_libdir}/libncurses.so.6 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses.so.6.0 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses.so.6.0 %{buildroot}%{_libdir}/libncurses.so.6.0
ln -s /%{_lib}/libncurses.so.6 %{buildroot}%{_libdir}/libncurses.so.6

mv %{buildroot}%{_libdir}/libncursesw.so.6 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncursesw.so.6.0 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncursesw.so.6.0 %{buildroot}%{_libdir}/libncursesw.so.6.0
ln -s /%{_lib}/libncursesw.so.6 %{buildroot}%{_libdir}/libncursesw.so.6

mv %{buildroot}%{_libdir}/libncurses++.so.6 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libncurses++.so.6.0 %{buildroot}/%{_lib}
ln -s /%{_lib}/libncurses++.so.6.0 %{buildroot}%{_libdir}/libncurses++.so.6.0
ln -s /%{_lib}/libncurses++.so.6 %{buildroot}%{_libdir}/libncurses++.so.6

mv %{buildroot}%{_libdir}/libtinfo.so.6 %{buildroot}/%{_lib}
mv %{buildroot}%{_libdir}/libtinfo.so.6.0 %{buildroot}/%{_lib}
ln -s /%{_lib}/libtinfo.so.6.0 %{buildroot}%{_libdir}/libtinfo.so.6.0
ln -s /%{_lib}/libtinfo.so.6 %{buildroot}%{_libdir}/libtinfo.so.6

#
# remove unneeded/unwanted files
#
rm -f %{buildroot}%{_libdir}/terminfo

# fwang: avoid conflict with kon package
rm -f %{buildroot}%{_datadir}/terminfo/k/kon

# as libtinfo is now build as a separate library, some symbols used to be in
# libncurses are now in libtinfo => drop private req and expose tinfo to linker
sed -i -e 's,Requires.private,Requires,g' %{buildroot}%{_libdir}/pkgconfig/ncurses*.pc

#
# FIXME
#
(cd %{buildroot} ; find usr/share/terminfo      -type d | perl -pe 's||%%dir /|') > %{name}.list
(cd %{buildroot} ; find usr/share/terminfo -not -type d | perl -pe 's||/|')       > %{name}-extraterms.list
perl -pe 's||%{_datadir}/terminfo/|' %{SOURCE5} >> %{name}.list

perl -ni -e 'BEGIN { open F, "%{name}.list"; /^%/ or $s{$_} = 1 foreach <F>; } print unless $s{$_}' %{name}-extraterms.list

%multiarch_includes %{buildroot}%{_includedir}/curses.h

# Don't require -ltinfo when linking with --no-add-needed
# This requires us to manually add the devel() provides that would normally
# be automatic but it's likely the lesser of two evils
for l in %{buildroot}%{_libdir}/libncurses{,w}.so; do
    soname=$(basename $(readlink $l))
    rm -f $l
    echo "INPUT($soname -ltinfo)" > $l
done

rm -f %{buildroot}%{_libdir}/libcurses{,w}.so
echo "INPUT(-lncurses)" > %{buildroot}%{_libdir}/libcurses.so
echo "INPUT(-lncursesw)" > %{buildroot}%{_libdir}/libcursesw.so

echo "INPUT(-ltinfo)" > %{buildroot}%{_libdir}/libtermcap.so

%files -f %{name}.list
%doc README ANNOUNCE
%{_datadir}/tabset
%{_bindir}/*
%{_mandir}/man1/*
%{_mandir}/man5/*
%{_mandir}/man7/*

%files -n %{lib5name}
%{_libdir}/libform.so.5*
%{_libdir}/libmenu.so.5*
%{_libdir}/libncurses.so.5*
%{_libdir}/libncurses++.so.5*
%{_libdir}/libpanel.so.5*
%{_libdir}/libtic.so.5*
%{_libdir}/libtinfo.so.5*
/%{_lib}/libncurses.so.5*
/%{_lib}/libncurses++.so.5*
/%{_lib}/libtinfo.so.5*

%files -n %{utf8lib5name}
%{_libdir}/lib*w.so.5*
/%{_lib}/libncursesw.so.5*

%files -n %{libname}
%{_libdir}/libform.so.%{major}*
%{_libdir}/libmenu.so.%{major}*
%{_libdir}/libncurses.so.%{major}*
%{_libdir}/libncurses++.so.%{major}*
%{_libdir}/libpanel.so.%{major}*
%{_libdir}/libtic.so.%{major}*
%{_libdir}/libtinfo.so.%{major}*
/%{_lib}/libncurses.so.%{major}*
/%{_lib}/libncurses++.so.%{major}*
/%{_lib}/libtinfo.so.%{major}*

%files -n %{utf8libname}
%{_libdir}/lib*w.so.%{major}*
/%{_lib}/libncursesw.so.%{major}*

%files extraterms -f %{name}-extraterms.list
%doc README

%files -n %{develname}
%doc doc c++
%{_libdir}/libcurses.a
%{_libdir}/libcurses.so
%{_libdir}/libform.a
%{_libdir}/libform.so
%{_libdir}/libmenu.a
%{_libdir}/libmenu.so
%{_libdir}/libncurses++.a
%{_libdir}/libncurses++.so
%{_libdir}/libncurses.a
%{_libdir}/libncurses.so
%{_libdir}/libpanel.a
%{_libdir}/libpanel.so
%{_libdir}/libtermcap.so
%{_libdir}/libtic.a
%{_libdir}/libtic.so
%{_libdir}/libtinfo.a
%{_libdir}/libtinfo.so
%{_libdir}/pkgconfig/form.pc
%{_libdir}/pkgconfig/menu.pc
%{_libdir}/pkgconfig/ncurses++.pc
%{_libdir}/pkgconfig/ncurses.pc
%{_libdir}/pkgconfig/panel.pc
%{_libdir}/pkgconfig/tic.pc
%{_libdir}/pkgconfig/tinfo.pc
%{_includedir}/*.h
%{_includedir}/ncurses
%multiarch %{multiarch_includedir}/curses.h
%{_mandir}/man3/*

%files -n %{utf8develname}
%{_includedir}/ncursesw
%{_libdir}/pkgconfig/*w.pc
%{_libdir}/lib*w.so
%{_libdir}/lib*w.a


%changelog
* Wed Sep 13 2017 bb2 <bb2> - 6.0-2pclos2017
- rebuild new gcc

* Wed Aug 09 2017 bb2 <bb2> - 6.0-1pclos2017
- new version

* Tue Feb 24 2015 bb <bb> - 5.9-9pclos2015
- rebuild new glibc

